////////////////////////////////////////////////////////////////////////
// pixel04.c
// Bouncing pixel
// Mochilote - www.cpcmania.com
////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>

void SetMode0PixelColor(unsigned char *pByteAddress, unsigned char nColor, unsigned char nPixel)
{
	unsigned char nByte = *pByteAddress;

	if(nPixel == 0)
	{
		nByte &= 85;

		if(nColor & 1)
			nByte |= 128;

		if(nColor & 2)
			nByte |= 8;

		if(nColor & 4)
			nByte |= 32;

		if(nColor & 8)
			nByte |= 2;
	}
	else
	{
		nByte &= 170;

		if(nColor & 1)
			nByte |= 64;

		if(nColor & 2)
			nByte |= 4;

		if(nColor & 4)
			nByte |= 16;

		if(nColor & 8)
			nByte |= 1;
	}

	*pByteAddress = nByte;
}

void PutPixelMode0(unsigned char nX, unsigned char nY, unsigned char nColor)
{
	unsigned char nPixel = 0;
	unsigned int nAddress = 0xC000 + ((nY / 8) * 80) + ((nY % 8) * 2048) + (nX / 2);
	nPixel = nX % 2;

	SetMode0PixelColor((unsigned char *)nAddress, nColor, nPixel);
}


void main()
{
	unsigned char *pScreen = (unsigned char *)0xC000;
	int nX = 81;
	int nY = 101;
	char nYDir = 1;
	char nXDir = 1;

	//SCR_SET_MODE 0
	__asm
		ld a, #0
		call #0xBC0E
	__endasm;

	while(1)
	{
		nX += nXDir;
		nY += nYDir;

		if(nX < 0)
		{
			nX = 0;
			nXDir = 1;
		}

		if(nX >= 160)
		{
			nX = 159;
			nXDir = -1;
		}

		if(nY < 0)
		{
			nY = 0;
			nYDir = 1;
		}

		if(nY >= 200)
		{
			nY = 199;
			nYDir = -1;
		}

		PutPixelMode0(nX, nY, rand() % 16);
	}
}
////////////////////////////////////////////////////////////////////////